/* $Id: SIDInstance.hh,v 1.3 2003/08/15 16:57:08 andete Exp $

lemux - LADSPA instrument plugins based on openMSX devices

(c) 2003 Joost Yervante Damad <joost@lumatec.be>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef   __SIDINSTANCE_HH__
#define   __SIDINSTANCE_HH__

#include <math.h>

#include "LADSPAPluginInstance.hh"

#include "resid/sid.h"

class SIDInstance: public LADSPAPluginInstance
{
public:
	SIDInstance(unsigned long sampleRate);
	virtual ~SIDInstance();

	virtual void connect_port(unsigned long port, LADSPA_Data* dataLocation);
	virtual void activate();
	virtual void run(unsigned long SampleCount);

private:

	// ladspa ports:
		// general
	LADSPA_Data* port_amp;					//  0
	LADSPA_Data* port_1_freq;				//  1
	LADSPA_Data* port_2_freq;				//  2
	LADSPA_Data* port_3_freq;				//  3
	LADSPA_Data* port_mos8580;				//  4
	LADSPA_Data* port_filter;				//  5
	LADSPA_Data* port_filter_ext;			//  6
	LADSPA_Data* port_filter_lp;			//  7
	LADSPA_Data* port_filter_bp;			//  8
	LADSPA_Data* port_filter_hp;			//  9
	LADSPA_Data* port_filter_cutoff_freq;	// 10
	LADSPA_Data* port_filter_resonance;		// 11
	LADSPA_Data* port_3off;					// 12
		//port 1
	LADSPA_Data* port_1_noise;				// 13
	LADSPA_Data* port_1_pulse;				// 14
	LADSPA_Data* port_1_pulse_width;		// 15
	LADSPA_Data* port_1_saw;				// 16
	LADSPA_Data* port_1_tri;				// 17
	LADSPA_Data* port_1_ringmod;			// 18
	LADSPA_Data* port_1_sync;				// 19
	LADSPA_Data* port_1_filter_on;			// 20
	LADSPA_Data* port_1_env_a;				// 21
	LADSPA_Data* port_1_env_d;				// 22
	LADSPA_Data* port_1_env_s;				// 23
	LADSPA_Data* port_1_env_r;				// 24
		//port 2
	LADSPA_Data* port_2_noise;				// 25
	LADSPA_Data* port_2_pulse;				// 26
	LADSPA_Data* port_2_pulse_width;		// 27
	LADSPA_Data* port_2_saw;				// 28
	LADSPA_Data* port_2_tri;				// 29
	LADSPA_Data* port_2_ringmod;			// 30
	LADSPA_Data* port_2_sync;				// 31
	LADSPA_Data* port_2_filter_on;			// 32
	LADSPA_Data* port_2_env_a;				// 33
	LADSPA_Data* port_2_env_d;				// 34
	LADSPA_Data* port_2_env_s;				// 35
	LADSPA_Data* port_2_env_r;				// 36
		//port 3
	LADSPA_Data* port_3_noise;				// 37
	LADSPA_Data* port_3_pulse;				// 38
	LADSPA_Data* port_3_pulse_width;		// 39
	LADSPA_Data* port_3_saw;				// 40
	LADSPA_Data* port_3_tri;				// 41
	LADSPA_Data* port_3_ringmod;			// 42
	LADSPA_Data* port_3_sync;				// 43
	LADSPA_Data* port_3_filter_on;			// 44
	LADSPA_Data* port_3_env_a;				// 45
	LADSPA_Data* port_3_env_d;				// 46
	LADSPA_Data* port_3_env_s;				// 47
	LADSPA_Data* port_3_env_r;				// 48
		// more generic
	LADSPA_Data* port_output;				// 49
	LADSPA_Data* port_1_gate;				// 50
	LADSPA_Data* port_2_gate;				// 51
	LADSPA_Data* port_3_gate;				// 52


	// constants
	const unsigned long sampleRate;
	const unsigned int step;

	// vars
	unsigned int Fn1_copy;
	unsigned int Fn2_copy;
	unsigned int Fn3_copy;

	LADSPA_Data port_1_gate_copy;
	LADSPA_Data port_2_gate_copy;
	LADSPA_Data port_3_gate_copy;

	// the SID from resid
	SID sid;

};

#endif // __SIDINSTANCE_HH__
